package com.example.sjkbf.entity;

import com.baomidou.mybatisplus.extension.api.IErrorCode;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class CommonResult<T> {
    // 状态码
    private Integer code;
    // 提示信息
    private String message;
    // 返回的数据
    private T data;

    /**
     * 成功返回结果
     *
     * @param data 返回的数据
     * @param <T>  数据类型
     * @return 通用返回对象
     */
    public static <T> CommonResult<T> success(T data) {
        return new CommonResult<>(200, "操作成功", data);
    }

    /**
     * 成功返回结果并自定义提示信息
     *
     * @param data    返回的数据
     * @param message 提示信息
     * @param <T>     数据类型
     * @return 通用返回对象
     */
    public static <T> CommonResult<T> success(T data, String message) {
        return new CommonResult<>(200, message, data);
    }


    /**
     * 失败返回结果并自定义提示信息
     *
     * @param message 提示信息
     * @param <T>     数据类型
     * @return 通用返回对象
     */
    public static <T> CommonResult<T> failed(String message) {
        return new CommonResult<>(500, message, null);
    }

    /**
     * 失败返回结果
     *
     * @param <T> 数据类型
     * @return 通用返回对象
     */
    public static <T> CommonResult<T> failed() {
        return failed(500, "操作失败");
    }

    /**
     * 失败返回结果
     *
     * @param code    错误码
     * @param message 提示信息
     * @param <T>     数据类型
     * @return 通用返回对象
     */
    public static <T> CommonResult<T> failed(int code, String message) {
        return new CommonResult<>(code, message, null);
    }

    /**
     * 参数验证失败返回结果
     *
     * @param <T> 数据类型
     * @return 通用返回对象
     */
    public static <T> CommonResult<T> validateFailed() {
        return failed(400, "参数验证失败");
    }

    /**
     * 参数验证失败返回结果并自定义提示信息
     *
     * @param message 提示信息
     * @param <T>     数据类型
     * @return 通用返回对象
     */
    public static <T> CommonResult<T> validateFailed(String message) {
        return failed(400, message);
    }

    /**
     * 未登录返回结果
     *
     * @param data 返回的数据
     * @param <T>  数据类型
     * @return 通用返回对象
     */
    public static <T> CommonResult<T> unauthorized(T data) {
        return new CommonResult<>(401, "暂未登录或 token 已经过期", data);
    }

    /**
     * 未授权返回结果
     *
     * @param data 返回的数据
     * @param <T>  数据类型
     * @return 通用返回对象
     */
    public static <T> CommonResult<T> forbidden(T data) {
        return new CommonResult<>(403, "没有相关权限", data);
    }
}